#include <stdarg.h> 
#include <stdio.h> 

/* minprintf: minimal version of printf with variable argument list */ 

void minprintf(char *fmt, ...) {
  va_list ap; /* points to each unnamed arg in trun */ 
  char *p, *sval; 
  int ival; 
  double dval; 
  
  va_start(ap, fmt); /* make ap point to 1st unnamed arg */ 
  for (p = fmt; *p; p ++) {
    if (*p != '%') {
      putchar(*p); 
      continue; 
    }
    switch (*++p){
    case 'd': 
      ival = va_arg (ap, int); 
      printf("%d", ival); 
      break; 
    case 'f': 
      dval = va_arg(ap, double); 
      printf("%f", dval); 
      break; 
    case 's': 
      for (sval = va_arg(ap, char *); *sval; sval++) 
	putchar(*sval); /* print the char *sval */ 
      break; 
    default: 
      putchar(*p); 
      break; 
    }   
  }
  va_end(ap); /* clean up when done */ 
}

main() {
  char *st = "this is a string"; 
  float f = 123.4567; 
  int i = 100; 

  minprintf(" this is an integer: :%d:\n", i); 
  minprintf(" this is a float:    :%f:\n", f); 
  minprintf(" this is a string:   :%s:\n", st); 

  minprintf(" this i, f and s:    :%d:%f:%s\n", i, f, st); 

}
